package interpreter;

import java.io.*;

import error.ErrorManager;

public class InteractiveLispInterpreter extends LispInterpreter {

    private static final String GREETING = "SUNY Potsdam Lisp Interpreter - Version 4.4.3";
    private static final String PROMPT = "~ ";

    public InteractiveLispInterpreter(InputStream inputStream, PrintStream outputStream, ErrorManager errorManager) {
        super(inputStream, outputStream, errorManager);
    }

    protected void printGreeting() {
        outputStream.println(GREETING);
        outputStream.println();
    }

    protected void displayPrompt() {
        outputStream.print(PROMPT);
    }

    protected void erasePrompt() {
        for (int i = 0; i < PROMPT.length(); i++) {
            outputStream.print("\b");
        }
    }
    
    protected void printFarewell() {
        outputStream.println();
        outputStream.println();
    }

}
